---
# Get already running instances
- name: Get deployed server information
  delegate_to: localhost
  openstack.cloud.server_info:
    auth: "{{ _openstack_project_auth }}"
    server: "{{ inventory_hostname }}"
  register: openstack_instance
  check_mode: false

# Run code when instances already existing
- name: Update ansible_host for existing instances
  set_fact:
    ansible_host: "{{ hostvars[inventory_hostname].openstack_instance.openstack_servers[0].interface_ip }}"
  check_mode: false
  when: openstack_instance.openstack_servers | length > 0

# Create the new instances using the deployment account
- name: Create instances
  delegate_to: localhost
  openstack.cloud.server:
    state: present
    auth: "{{ _openstack_project_auth }}"
    name: "{{ inventory_hostname }}"
    image: "{{ openstack_deploy_image_name }}"
    key_name: "{{ openstack_deploy_keyname }}"
    timeout: 200
    flavor: "{{ openstack_instance_flavor }}"
    network: "{{ openstack_network }}"
    security_groups: "{{ apply_security_groups }}"
    terminate_volume: true
    meta:
      hostname: "{{ inventory_hostname }}"
      service: "{{ openstack_project_name }}"
      service_owner: "{{ service_owner }}"
      service_team: "{{ service_team }}"
  register: new_openstack_instance
  when: (openstack_instance.openstack_servers | length == 0) or (os_security_groups.changed)
  check_mode: false

# Set ansible_host to IP address
- name: Update ansible_host for new instances
  set_fact:
    ansible_host: "{{ new_openstack_instance.openstack.interface_ip  }}"
  when: openstack_instance.openstack_servers | length == 0
  check_mode: false
...
